package de.urszeidler.eclipse.callchain.emfgenerators.executables;

import java.io.IOException;
import java.util.ArrayList;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.ui.actions.RetargetAction;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.generatorservice.executables.AbstractExecuteable;

/**
 * The basic emf executor class.
 * @author urs
 *
 */
public abstract class AbstractEmfExecutable extends AbstractExecuteable {
	
	protected static final String GENNODEL_URI = "http://www.eclipse.org/emf/2002/GenModel";


	public AbstractEmfExecutable() {
		super();
	}

	protected Model getEcoreModel(EList<Artifact> uses) {
		return findModelByMetaModel(uses, "#EMF");
	}

	

//	protected static Resource internalLoad(ResourceSet resourceSet, URI uri) {
//		Diagnostic diagnostic = Diagnostic.OK_INSTANCE;
//		Resource resource = resourceSet.createResource(uri);
//		if(resource==null)
//			return null;
//		
//		
//		Exception rootException = null;
//		try {
//			resource.load(resourceSet.getLoadOptions());
//		} catch (IOException e) {
//			rootException = e instanceof Resource.IOWrappedException ? (Exception) e
//					.getCause()
//					: e;
//			// include only non diagnostic exception in resource.getErrors()
//			// if(!(e instanceof Resource.Diagnostic)) {
//			//resource.getErrors().add(ModelLoadHelper.createDiagnostic(resource
//			// , rootException));
//			// }
//		} catch (RuntimeException e) {
//			EcorePlugin.INSTANCE.getPluginLogger().log(e);
//			//resource.getErrors().add(ModelLoadHelper.createDiagnostic(resource
//			// , e));
//		}
////		EList<Resource.Diagnostic> errors = resource.getErrors();
////		EList<Resource.Diagnostic> warnings = resource.getWarnings();
////		if (!errors.isEmpty() || !warnings.isEmpty()) {
////			Diagnostic resourceDiagnostic = EcoreUtil.computeDiagnostic(
////					resource, true);
////			Integer severityOpt = new Integer(
////					resourceDiagnostic.getSeverity() == Diagnostic.ERROR ? 0
////							: 1);
////			// String message =
////			// MessageFormat.format(Messages.modelLoadedWithProblems,
////			// new Object[] { severityOpt, resource.getURI() });
////
////			Object[] data = (rootException != null) ? new Object[] {
////					rootException, resource } : new Object[] { resource };
////			// BasicDiagnostic loadDiagnostic = new
////			// BasicDiagnostic(DIAGNOSTIC_SOURCE, resourceDiagnostic.getCode(),
////			// message, data);
////			// loadDiagnostic.addAll(resourceDiagnostic);
////			// diagnostic = loadDiagnostic;
////		}
//		return resource;
//	}

}