package de.urszeidler.eclipse.callchain.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.parsers.MessageFormatParser;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;

/**
 * @generated
 */
public class CallchainParserProvider extends AbstractProvider implements IParserProvider {

	/**
	 * @generated
	 */
	private IParser modelUri_5031Parser;

	/**
	 * @generated
	 */
	private IParser getModelUri_5031Parser() {
		if (modelUri_5031Parser == null) {
			modelUri_5031Parser = createModelUri_5031Parser();
		}
		return modelUri_5031Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createModelUri_5031Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser modelName_5032Parser;

	/**
	 * @generated
	 */
	private IParser getModelName_5032Parser() {
		if (modelName_5032Parser == null) {
			modelName_5032Parser = createModelName_5032Parser();
		}
		return modelName_5032Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createModelName_5032Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser atlResUri_5033Parser;

	/**
	 * @generated
	 */
	private IParser getAtlResUri_5033Parser() {
		if (atlResUri_5033Parser == null) {
			atlResUri_5033Parser = createAtlResUri_5033Parser();
		}
		return atlResUri_5033Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAtlResUri_5033Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser atlResName_5034Parser;

	/**
	 * @generated
	 */
	private IParser getAtlResName_5034Parser() {
		if (atlResName_5034Parser == null) {
			atlResName_5034Parser = createAtlResName_5034Parser();
		}
		return atlResName_5034Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAtlResName_5034Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser callName_5035Parser;

	/**
	 * @generated
	 */
	private IParser getCallName_5035Parser() {
		if (callName_5035Parser == null) {
			callName_5035Parser = createCallName_5035Parser();
		}
		return callName_5035Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createCallName_5035Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser mMHandler_5036Parser;

	/**
	 * @generated
	 */
	private IParser getMMHandler_5036Parser() {
		if (mMHandler_5036Parser == null) {
			mMHandler_5036Parser = createMMHandler_5036Parser();
		}
		return mMHandler_5036Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createMMHandler_5036Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getMM_Handler(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser mMUri_5037Parser;

	/**
	 * @generated
	 */
	private IParser getMMUri_5037Parser() {
		if (mMUri_5037Parser == null) {
			mMUri_5037Parser = createMMUri_5037Parser();
		}
		return mMUri_5037Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createMMUri_5037Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser mMName_5038Parser;

	/**
	 * @generated
	 */
	private IParser getMMName_5038Parser() {
		if (mMName_5038Parser == null) {
			mMName_5038Parser = createMMName_5038Parser();
		}
		return mMName_5038Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createMMName_5038Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser atlLibaryUri_5039Parser;

	/**
	 * @generated
	 */
	private IParser getAtlLibaryUri_5039Parser() {
		if (atlLibaryUri_5039Parser == null) {
			atlLibaryUri_5039Parser = createAtlLibaryUri_5039Parser();
		}
		return atlLibaryUri_5039Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAtlLibaryUri_5039Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser atlLibaryName_5040Parser;

	/**
	 * @generated
	 */
	private IParser getAtlLibaryName_5040Parser() {
		if (atlLibaryName_5040Parser == null) {
			atlLibaryName_5040Parser = createAtlLibaryName_5040Parser();
		}
		return atlLibaryName_5040Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAtlLibaryName_5040Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser artifactName_5041Parser;

	/**
	 * @generated
	 */
	private IParser getArtifactName_5041Parser() {
		if (artifactName_5041Parser == null) {
			artifactName_5041Parser = createArtifactName_5041Parser();
		}
		return artifactName_5041Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createArtifactName_5041Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser artifactUri_5042Parser;

	/**
	 * @generated
	 */
	private IParser getArtifactUri_5042Parser() {
		if (artifactUri_5042Parser == null) {
			artifactUri_5042Parser = createArtifactUri_5042Parser();
		}
		return artifactUri_5042Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createArtifactUri_5042Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser commentDoc_5048Parser;

	/**
	 * @generated
	 */
	private IParser getCommentDoc_5048Parser() {
		if (commentDoc_5048Parser == null) {
			commentDoc_5048Parser = createCommentDoc_5048Parser();
		}
		return commentDoc_5048Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createCommentDoc_5048Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getComment_Doc(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser generic_GeneratorName_5053Parser;

	/**
	 * @generated
	 */
	private IParser getGeneric_GeneratorName_5053Parser() {
		if (generic_GeneratorName_5053Parser == null) {
			generic_GeneratorName_5053Parser = createGeneric_GeneratorName_5053Parser();
		}
		return generic_GeneratorName_5053Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createGeneric_GeneratorName_5053Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser modelAliasAliasName_6003Parser;

	/**
	 * @generated
	 */
	private IParser getModelAliasAliasName_6003Parser() {
		if (modelAliasAliasName_6003Parser == null) {
			modelAliasAliasName_6003Parser = createModelAliasAliasName_6003Parser();
		}
		return modelAliasAliasName_6003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createModelAliasAliasName_6003Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getModelAlias_AliasName(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser mMAliasAliasName_6004Parser;

	/**
	 * @generated
	 */
	private IParser getMMAliasAliasName_6004Parser() {
		if (mMAliasAliasName_6004Parser == null) {
			mMAliasAliasName_6004Parser = createMMAliasAliasName_6004Parser();
		}
		return mMAliasAliasName_6004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createMMAliasAliasName_6004Parser() {
		EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getMMAlias_AliasName(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case ModelUriEditPart.VISUAL_ID:
			return getModelUri_5031Parser();
		case ModelNameEditPart.VISUAL_ID:
			return getModelName_5032Parser();
		case AtlResUriEditPart.VISUAL_ID:
			return getAtlResUri_5033Parser();
		case AtlResNameEditPart.VISUAL_ID:
			return getAtlResName_5034Parser();
		case CallNameEditPart.VISUAL_ID:
			return getCallName_5035Parser();
		case MMHandlerEditPart.VISUAL_ID:
			return getMMHandler_5036Parser();
		case MMUriEditPart.VISUAL_ID:
			return getMMUri_5037Parser();
		case MMNameEditPart.VISUAL_ID:
			return getMMName_5038Parser();
		case AtlLibaryUriEditPart.VISUAL_ID:
			return getAtlLibaryUri_5039Parser();
		case AtlLibaryNameEditPart.VISUAL_ID:
			return getAtlLibaryName_5040Parser();
		case ArtifactNameEditPart.VISUAL_ID:
			return getArtifactName_5041Parser();
		case ArtifactUriEditPart.VISUAL_ID:
			return getArtifactUri_5042Parser();
		case CommentDocEditPart.VISUAL_ID:
			return getCommentDoc_5048Parser();
		case Generic_GeneratorNameEditPart.VISUAL_ID:
			return getGeneric_GeneratorName_5053Parser();
		case ModelAliasAliasNameEditPart.VISUAL_ID:
			return getModelAliasAliasName_6003Parser();
		case MMAliasAliasNameEditPart.VISUAL_ID:
			return getMMAliasAliasName_6004Parser();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(CallchainVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(CallchainVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (CallchainElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
